/**
#---------------------------------------------------------------------#
#                   	Mega-Chess V1.0 			      #
#                              					      #
#                  A simple tiny portable Mega Chess Game             #
#								      #
#                                                                     #
# (c)opyright 2001 all rights reserved                                #
#							              #	
# Authors: Open Source community with A.Costa et al                   #
#                                                                     #
#                                                                     #
# For info and support visit:                                         #
#								      #
# http://sourceforge.net/p/mega-chess 				      #            
#                  						      #
# Or								      #
#								      #
# http://www.seesolutions.it/mega-chess 			      #
#---------------------------------------------------------------------#
#
#

LICENSE

To be distributed with following text and gpl.txt file only:
Append your own license

GNU GPL (see gpl.txt)

Unless required by applicable law or agreed to in writing, software distributed
under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
OF ANY KIND, either express or implied. See the License for the specific language
governing permissions and limitations under the License.

DISCLAIMER

THIS SOFTWARE AVAILABLE ON THE SITE www.seesolutions.it IS PROVIDED
"AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL SEE Solutions OR ANY OF THEIR CONTRIBUTORS
BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

Without limiting the foregoing, SEE Solutions make no warranty that:

- the software will meet your requirements.
- the software will be uninterrupted, timely, secure or error-free.
- the results that may be obtained from the use of the software will be effective, accurate or reliable.
- the quality of the software will meet your expectations.
- any errors in the software obtained from the SEE Solutions web site will be corrected.
- Software and its documentation made available on the SEE Solutions web site:

could include technical or other mistakes, inaccuracies or typographical errors.
SEE contributors may make changes to the software or documentation made available
on its web site. may be out of date and SEE Solutions and its contributors make no
commitment to update such materials.

SEE Solutions and its contributors assume no responsibility for errors or ommissions
in the software or documentation available from the SEE Solutions web site.

In no event shall SEE Solutions, or it's contributors be liable to you or any third parties
for any special, punitive, incidental, indirect or consequential damages of any kind,
or any damages whatsoever, including, without limitation, those resulting from loss of
use, data or profits, whether or not SEE Solutions, or its contributors has been advised
of the possibility of such damages, and on any theory of liability, arising out of
or in connection with the use of this software.

The use of the software downloaded through the SEE Solutions site is done at your own
discretion and risk and with agreement that you will be solely responsible for any
amage to your computer system or loss of data that results from such activities.
No advice or information, whether oral or written, obtained by you from SEE Solutions,
its its website or its contributors shall create any warranty for the software.


For more information contact:  info@seesolutions.it
*/

/**
*This Chessboard-applet is the result of a programming project performed by:
*Armin Costa, Stefan Pizzinini, Davide Schuen and Ivan Granruaz.
*
*The applet with all included sources can be downloaded form
*http://www.mega.chess.da.ru for exclusive non-profic scopes in the hope it may be useful
*for academic purposes.
*
*@version Mega-Chess V1.1
*@authors Armin Costa, Ivan Granruaz, Stefan Pizzinini, Davide Schuen
*/

import java.awt.*;
import java.net.*;
import java.util.*;
import java.awt.event.*;

/**

*/
public class MegaChess extends  java.applet.Applet implements ActionListener
{
    /*Main Class      */


    /**Constructor of the ChessMove class containing all move-related methods*/
    ChessMoves moveFig;
    /**array containing all figure images*/
    public Image img[] = new Image[13];
    /** array mapping the positions -- position (i,j)  (a1 = 0,0; b3= 2,3; h8 = 7,7, etc.)  */
    public int board [][];
    /**used to store the taken black figures*/
    public int takenBlack[] = new int[16];
    /**index to keep track of the black figures taken*/
    public int takenBlackNum = 0;
    /** used to store the taken white figures*/
    public int takenWhite[] = new int[16];
    /**index to keep track of the white figures taken */
    public int takenWhiteNum = 0;
    /**size of the squares in pixel*/
    public int sqsize = 32;
    /**number of rows and columns in the board  */
    public int rows = 8, columns = 8 ;
    /**used to store the corresponing row and colums clicked*/
    public int rowClicked, colClicked;
    /**variable used to pass the beginning status to ChessMoves()  */
    public int beginning = 1;
    /**Forsythe notation -- used to fill the board[][] array  -- "rnbqkbnr/pppppppp/////PPPPPPPP/RNBQKBNR"; */
    public String setup = "rnbqkbnr/pppppppp/////PPPPPPPP/RNBQKBNR";
    Panel links;
    Panel controls;
    MediaTracker tracker = new MediaTracker(this);
    /**Version variable  */
    String version = "V1.1";
    /** TextField used to display game related information */
    TextField ta = new TextField(50);
    TextField log = new TextField(50);
    Button white = new Button("white");
    Button black = new Button("black");
    /** varialbe which stores the player which moved last : 0 - white, 1 - black  */
    public int lastplayermoved = 1;
    /**kepps track of the last move */
    Move lastmove;
    private boolean mouseEnter;
    private boolean mouseExit;
    /**variable which keeps track of the number of moves done. Used for the "50 moves rule"  */
    int moveNumber = 0;




    /**called when the applets is being executed- Loads the images and builds GUI  */
    public void init()
    {
        LoadImages();
        reset();

        white.addActionListener(this);
        black.addActionListener(this);

        // Area for messages
        ta.setFont( new Font ("Helvetica", Font.BOLD, 12));
        ta.setEditable(false);
        ta.setBackground( Color.white);
        ta.setText("WHITE beginns!!");

        controls = new Panel();
        controls.setLayout( new GridLayout(1, 4));
        controls.add(white);
        controls.add(black);
        controls.add(ta);
        controls.add(log);

        links   = new Panel();
        links.setLayout( new BorderLayout ());

        setLayout( new BorderLayout());
        add (links);
        add("South", controls);
        resize  (500, 315);
    }


 /**
 *this method is used to to reset the chessboard in case of a new game and for back-moves.
 *It also resets int takenWhite Num and takenBlackNum to value 0 in order to ensure a correct sequential drawing of the taken
 *figures.
 *Forsythe notation:  "rnbqkbnr/pppppppp/////PPPPPPPP/RNBQKBNR"
 */
 public void reset (){
        if (moveNumber >0) moveNumber--;
        rowClicked = -1;
        board   = new int [columns][rows];
        ForsytheToBoard();
        moveFig = new ChessMoves(this);
        takenWhiteNum = 0;
        takenBlackNum = 0;
        ta.setText("WHITE beginns!");
 }


 /**
 *This method, called from reset(), fills the board[x][y] array with the correct figure position
 *according to the Forsythe notation.
 *Forsythe notation:  "rnbqkbnr/pppppppp/////PPPPPPPP/RNBQKBNR"
 */
 public void ForsytheToBoard (){ // Gets a board string in Forsythe notation
        int x = 0, y = rows-1;
        for( int place = 0; place < setup.length(); place++){
            char c = setup.charAt(place);
            if (c == '/'){
                x=0;
                y--;
            }else if (x<columns && y>-1) {
                board[x][y]=" KkQqRrNnBbPp".indexOf(c);
                x++;
            }
        }
 }


 /**
 *this method handels all mouse operations used to move the figures and to reset the board
 *@param x mouse coordinate
 *@param y mouse coordinate
 */
 public boolean mouseDown (Event e, int x, int y){
        if (e.modifiers != 0) {    // right mouse button - reset or back move
            if (e.clickCount > 1) { // righ mouse button double click - reset
                moveNumber = 0;
                reset();
            } else {                // back move
                reset();
            }
        } else {
            clickProcessing ( x/sqsize, rows - y/sqsize - 1);
        }
        repaint();
        return true;
 }


 /**
 *when called insede the MouseListener method mouseDown(), it handels the move itself checking
 *wheather the move is allowed and if so, it calls DoMove(colClicked, rowClicked, i , j) to
 *perform the actual move. Is also checks if the moved Figure is in Check or not.
 *@param i gets the processed x-coordinate from mouseDown
 *@param j gets the processed y-coordinate form mouseDown
 */
 void clickProcessing (int i, int j){         // i - column, j - row
        if (rowClicked == -1) { // First click : from where the player should move ?
            if ( (board[i][j] > 0) &&  moveFig.RightPlayer(i,j)){ // not empty and ...

                colClicked = i;
                rowClicked = j;
            }
        } else { // Second click : to which square player should move

            if (i == colClicked && j == rowClicked) {
                rowClicked = -1; // if clicked on same square, clicking undone
            }
            else if (moveFig.LegalMove   (colClicked,rowClicked,i,j) &&
                     moveFig.RightPlayer (colClicked,rowClicked) ) {
                // Back move preparation - push current state to stack

                takenFig(colClicked, rowClicked, i, j);
                moveFig.DoMove (colClicked,rowClicked,i,j);

                for(int k1 = 0; k1 < 8; k1++){
                    for(int r1 = 0; r1 < 8; r1++){
                        if(board[k1][r1] == 1){
                              if(moveFig.isItInCheck(1, k1, r1)){
                                ta.setText("white in CHECK");
                              }
                        }else if(board[k1][r1] == 2){
                            if(moveFig.isItInCheck(0, k1, r1)){
                                ta.setText("balck in CHECK");
                            }
                        }
                     }
                  }

                rowClicked = -1;

            }
        }
 }


 /**
*the paint method draws the chess-board itself with all default figure positions.
*For drawing the board it calls drawsquare(g, i, j);
*For drawing the figures it calls drawpiece(g, i, j);
*It also handels the taken figures operations by calling paintImageTakenWhite(g) and
*paintImageTakenBlack(g);
 */
 public void paint (Graphics g){
        for (int i = 0; i<columns ; i++){
            for (int j = 0; j<rows ; j++){
                drawsquare (g,i,j);
            }
        }
        for (int i = 0; i<columns ; i++){
            for (int j = 0; j<rows ; j++){
                drawpiece (g,i,j);
            }
        }

        paintImageTakenWhite(g);
        paintImageTakenBlack(g);

        g.setColor(Color.black);
        g.drawString("www.mega-chess.da.ru :-) MEGA-CHESS" + version,10,270);
        g.drawString(" by Armin Costa, Schuhen Davide, Stefan Pizzinini,",10,280);
        g.drawString("Granruaz Ivan", 10, 290);
        g.setFont(new Font("Helvetica", 1, 9));
        g.drawString("WHITE taken:", 300, 10);
        g.drawString("BLACK taken:", 400, 10);
        g.drawString("MOVED last /  STATUS", 260, 290);
        g.drawString("50-MOVES rule / # of moves", 370, 290);
 }


 /**
 *called by the paint() method inside 2 for-loops is draws the gray and black fields at the
 *corresponding positions
 *@param i value of the column-index in the forloop implemented in the paint() method
 *@param j value of the row-index in the forloop implemented in the paint() method
 */
 public void drawsquare (Graphics g,int i,int j) {    // draw color square at the beginning
        Color c = ((i+j) % 2 == 0) ? Color.gray : Color.white;
        if (i==colClicked && j==rowClicked)  c = Color.red ;
        g.setColor(c);
        g.fillRect(i*sqsize, (rows-j-1)* sqsize, sqsize, sqsize);
 }


 /**
 *called by the paint() method inside 2 for-loops is draws the relative figures already mapped
 *in the two-dimensional array board[][] in the correct position
 *@param i value of the column-index in the forloop implemented in the paint() method
 *@param j value of the row-index in the forloop implemented in the paint() method
 */
 public void drawpiece (Graphics g, int i,int j){ // drawpiece on position (i,j)
        Image image = img [ board [i][j] ];
        if (image != null)
            g.drawImage (image, i*sqsize, (rows-j-1)*sqsize,sqsize,sqsize,this);
 }


 /**
 this method uses MediaTracker to load the figure-images and store them in the array img[]
 */
 public void LoadImages (){
        String inames[] = { "kingw","kingb","queenw","queenb","rookw","rookb",
                            "knightw","knightb","bishopw","bishopb","pawnw","pawnb"};
        for (int i=0; i< 12; i++)
            try { img[i+1] = getImage(new URL(getDocumentBase(),inames[i]+".gif"));
            tracker.addImage( img[i+1], 0);
            } catch (Exception e){}
        try {tracker.waitForAll();} catch (Exception e) {}; // Wait to image loading
 }

/**
*called from clickProcessing(i, j) method it checks the corresponding figure taken and fills
*the array  in order to paint the figure taken
*@param k1 startcolon
*@param r1 start row
*@param k2 destination column
*@param r2 destination row
*/
 public void takenFig(int k1, int r1, int k2, int r2){
        if((moveFig.PieceOwner(k2, r2) == 0)&& (!moveFig.TakingPieceOfSameColor(k1, r1, k2, r2))){
            //ta.setText("white taken ");
            takenWhite[takenWhiteNum] = board[k2][r2];
            takenWhiteNum++;
        }else if((moveFig.PieceOwner(k2, r2) == 1) && (!moveFig.TakingPieceOfSameColor(k1, r1, k2, r2))){
          //ta.setText("black taken");
          takenBlack[takenBlackNum] = board[k2][r2];
          takenBlackNum++;
        }
 }


 /**
 this method, called inside the paint() method draws the taken white figures every time the applet
 gets repainted.
 */
 public void paintImageTakenWhite(Graphics g) {
      int pos = 290;
        for (int i = 0; i < takenWhiteNum; i++) {
            Image imagetaken = img[takenWhite[i]];
            g.drawImage(imagetaken, 290, 20 + i * sqsize, sqsize, sqsize, this);
        }
 }


  /**
 this method, called inside the paint() method draws the taken black figures every time the applet
 gets repainted.
 */
 public void paintImageTakenBlack(Graphics g) {
        for (int i = 0; i < takenBlackNum; i++) {
            Image imagetaken = img[takenBlack[i]];
            g.drawImage(imagetaken, 380, 20 + i * sqsize, sqsize, sqsize, this);
        }
 }


 /**
* this method handels all actions associated with botton click, namely is resets the chessboard
* and sets the lastpayermoved variable to the desired value (white begins or black begins)
*@see java.awt.event.*;
 */
 public void actionPerformed(ActionEvent e){
        if (e.getSource() == white){
            reset();
            lastplayermoved = 1;
            beginning = 1;
            ta.setText("WHITE begins");
            log.setText("  ");
            repaint();
        }else if(e.getSource() == black){
            reset();
            lastplayermoved = 0;
            beginning = 0;
            ta.setText("BLACK begins");
            log.setText("  ");
            repaint();
        }
    }
}
