/**
#---------------------------------------------------------------------#
#                   	Mega-Chess V1.0 			      #
#                              					      #
#                  A simple tiny portable Mega Chess Game             #
#								      #
#                                                                     #
# (c)opyright 2001 all rights reserved                                #
#							              #	
# Authors: Open Source community with A.Costa et al                   #
#                                                                     #
#                                                                     #
# For info and support visit:                                         #
#								      #
# http://sourceforge.net/p/mega-chess 				      #            
#                  						      #
# Or								      #
#								      #
# http://www.seesolutions.it/mega-chess 			      #
#---------------------------------------------------------------------#
#
#

LICENSE

To be distributed with following text and gpl.txt file only:
Append your own license

GNU GPL (see gpl.txt)

Unless required by applicable law or agreed to in writing, software distributed
under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
OF ANY KIND, either express or implied. See the License for the specific language
governing permissions and limitations under the License.

DISCLAIMER

THIS SOFTWARE AVAILABLE ON THE SITE www.seesolutions.it IS PROVIDED
"AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL SEE Solutions OR ANY OF THEIR CONTRIBUTORS
BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.

Without limiting the foregoing, SEE Solutions make no warranty that:

- the software will meet your requirements.
- the software will be uninterrupted, timely, secure or error-free.
- the results that may be obtained from the use of the software will be effective, accurate or reliable.
- the quality of the software will meet your expectations.
- any errors in the software obtained from the SEE Solutions web site will be corrected.
- Software and its documentation made available on the SEE Solutions web site:

could include technical or other mistakes, inaccuracies or typographical errors.
SEE contributors may make changes to the software or documentation made available
on its web site. may be out of date and SEE Solutions and its contributors make no
commitment to update such materials.

SEE Solutions and its contributors assume no responsibility for errors or ommissions
in the software or documentation available from the SEE Solutions web site.

In no event shall SEE Solutions, or it's contributors be liable to you or any third parties
for any special, punitive, incidental, indirect or consequential damages of any kind,
or any damages whatsoever, including, without limitation, those resulting from loss of
use, data or profits, whether or not SEE Solutions, or its contributors has been advised
of the possibility of such damages, and on any theory of liability, arising out of
or in connection with the use of this software.

The use of the software downloaded through the SEE Solutions site is done at your own
discretion and risk and with agreement that you will be solely responsible for any
amage to your computer system or loss of data that results from such activities.
No advice or information, whether oral or written, obtained by you from SEE Solutions,
its its website or its contributors shall create any warranty for the software.


For more information contact:  info@seesolutions.it
*/
/**
*class that adjusts the values in order to enable the DoMove(..) method in MegaChess class
*to perform the actual move
*
*
*@version Mega-Chess V1.1
*@authors Armin Costa, Ivan Granruaz, Stefan Pizzinini, Davide Schuen
*
*/

public class Move{
  /**start- row and columns    destination- rows and columns*/
  public int startrow, endrow, startcol, endcol;

  /**set the start-end koordinates startrow,endrow,startcol,endcol to 0
  */
  Move()
  {  startrow = endrow = startcol = endcol = 0; }
  /**set the start-end koordinates of the moved figure
  *startrow=r1, endrow=r2, startcol=k1, endcol=k2
  */
  Move(int k1, int r1, int k2, int r2)
  {  startcol = k1; startrow = r1; endcol = k2; endrow = r2;  }

  /**isvoid return true if no moves(sum of all moves=0)
  */
  boolean isvoid()
  {  return (startrow+endrow+startcol+endcol)==0 ?  true : false; }
}
